%global flavor gcc32winthr

%global __strip %{_mingw32_strip}
%global __objdump %{_mingw32_objdump}
%global _use_internal_dependency_generator 0
%global __find_requires %{_mingw32_findrequires}
%global __find_provides %{_mingw32_findprovides}
%define __debug_install_post %{_mingw32_debug_install_post}

%global oname globus-gssapi-gsi
%global _name %(tr - _ <<< %{oname})

Name:		mingw32-%{oname}
Version:	7.8
Release:	1%{?dist}
Summary:	Globus Toolkit for MinGW - GSSAPI library

Group:		Development/Libraries
License:	ASL 2.0
URL:		http://www.globus.org/
#		Source is extracted from the globus toolkit installer:
#		wget -N http://www-unix.globus.org/ftppub/gt5/5.0/5.0.4/installers/src/gt5.0.4-all-source-installer.tar.bz2
#		tar -jxf gt5.0.4-all-source-installer.tar.bz2
#		mv gt5.0.4-all-source-installer/source-trees/gsi/gssapi/source globus_gssapi_gsi-7.8
#		cp -p gt5.0.4-all-source-installer/source-trees/core/source/GLOBUS_LICENSE globus_gssapi_gsi-7.8
#		tar -zcf globus_gssapi_gsi-7.8.tar.gz globus_gssapi_gsi-7.8
Source:		%{_name}-%{version}.tar.gz
BuildArch:	noarch
BuildRoot:	%{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)

Requires:	mingw32-globus-openssl >= 1
BuildRequires:	grid-packaging-tools
BuildRequires:	mingw32-globus-gsi-credential >= 1
BuildRequires:	mingw32-globus-gsi-callback
BuildRequires:	mingw32-globus-openssl-module
BuildRequires:	mingw32-globus-gsi-openssl-error
BuildRequires:	mingw32-globus-openssl >= 1
BuildRequires:	mingw32-globus-gsi-proxy-core >= 1
BuildRequires:	mingw32-globus-core >= 4
BuildRequires:	mingw32-globus-gsi-cert-utils >= 5
BuildRequires:	mingw32-globus-common >= 3
BuildRequires:	mingw32-filesystem
BuildRequires:	mingw32-gcc

%description
The Globus Toolkit is an open source software toolkit used for building Grid
systems and applications. It is being developed by the Globus Alliance and
many others all over the world. A growing number of projects and companies are
using the Globus Toolkit to unlock the potential of grids for their cause.

The %{name} package contains:
GSSAPI library

%{?_mingw32_debug_package}

%prep
%setup -q -n %{_name}-%{version}

%build
export GLOBUS_LOCATION=%{_mingw32_prefix}

# Remove files that should be replaced during bootstrap
rm -f doxygen/Doxyfile*
rm -f doxygen/Makefile.am
rm -f pkgdata/Makefile.am
rm -f globus_automake*
rm -rf autom4te.cache

# Remove flavor tags
for f in `find . -name Makefile.am` ; do
  sed -e 's!^flavorinclude_HEADERS!include_HEADERS!' \
      -e 's!\(lib[a-zA-Z_]*\)_$(GLOBUS_FLAVOR_NAME)\.la!\1.la!g' \
      -e 's!^\(lib[a-zA-Z_]*\)___GLOBUS_FLAVOR_NAME__la_!\1_la_!' -i $f
done
sed -e "s!<With_Flavors!<With_Flavors ColocateLibraries=\"no\"!" \
  -i pkgdata/pkg_data_src.gpt.in

%{_mingw32_datadir}/globus/globus-bootstrap.sh

%_mingw32_configure --with-flavor=%{flavor}

make %{?_smp_mflags}

%install
export GLOBUS_LOCATION=%{_mingw32_prefix}

rm -rf $RPM_BUILD_ROOT
make install DESTDIR=$RPM_BUILD_ROOT

GLOBUSPACKAGEDIR=$RPM_BUILD_ROOT%{_mingw32_datadir}/globus/packages

# Remove static libraries (.a files)
rm $RPM_BUILD_ROOT%{_mingw32_libdir}/libglobus_gssapi_gsi.a
sed '/libglobus_gssapi_gsi.a$/d' \
  -i $GLOBUSPACKAGEDIR/%{_name}/%{flavor}_dev.filelist

# Generate pkg-config file from GPT metadata
mkdir -p $RPM_BUILD_ROOT%{_mingw32_libdir}/pkgconfig
%{_mingw32_datadir}/globus/mingw32-globus-gpt2pkg-config \
  pkgdata/pkg_data_%{flavor}_dev.gpt > \
  $RPM_BUILD_ROOT%{_mingw32_libdir}/pkgconfig/%{oname}.pc

# Install license file
mkdir -p $RPM_BUILD_ROOT%{_mingw32_docdir}/%{name}-%{version}
install -m 644 -p GLOBUS_LICENSE \
  $RPM_BUILD_ROOT%{_mingw32_docdir}/%{name}-%{version}

# Generate package filelists
cat $GLOBUSPACKAGEDIR/%{_name}/%{flavor}_rtl.filelist \
    $GLOBUSPACKAGEDIR/%{_name}/%{flavor}_dev.filelist \
  | sed s!^!%{_mingw32_prefix}! > package.filelist

%clean
rm -rf $RPM_BUILD_ROOT

%files -f package.filelist
%defattr(-,root,root,-)
%dir %{_mingw32_datadir}/globus/packages/%{_name}
%{_mingw32_libdir}/pkgconfig/%{oname}.pc
%{_mingw32_bindir}/libglobus_gssapi_gsi-4.dll
%dir %{_mingw32_docdir}/%{name}-%{version}
%doc %{_mingw32_docdir}/%{name}-%{version}/GLOBUS_LICENSE

%changelog
* Thu Jun 23 2011 Mattias Ellert <mattias.ellert@fysast.uu.se> - 7.8-1
- Update to Globus Toolkit 5.0.4

* Mon May 03 2010 Mattias Ellert <mattias.ellert@fysast.uu.se> - 7.5-1
- Update to Globus Toolkit 5.0.1
- Drop patch globus-gssapi-gsi-openssl.patch (fixed upstream)

* Wed Mar 10 2010 Mattias Ellert <mattias.ellert@fysast.uu.se> - 7.0-2
- Add debug package

* Sun Mar 07 2010 Mattias Ellert <mattias.ellert@fysast.uu.se> - 7.0-1
- Update to Globus Toolkit 5.0.0

* Wed May 06 2009 Mattias Ellert <mattias.ellert@fysast.uu.se> - 5.9-1
- Autogenerated
